tutorials/learned/urls.py
from django.urls import path
from . import views

app_name='learned'

urlpatterns = [
    path('', views.IndexView.as_view(), name='index' ),
    path('<int:pk>/', views.ContentDetailView.as_view(), name='detail'),
    path('search/', views.search, name='search'),
    path('all/', views.all, name='all'),

]

tutorials/tutorials/urls.py
from django.contrib import admin
from django.urls import path, include
from . import views


urlpatterns = [
    path('', views.index, name='index'),
    path('admin/', admin.site.urls),
    path('learned/', include('learned.urls', namespace='learned')),

]

tutorials/learned/models.py
from django.utils.translation import gettext_lazy as _
from django.db import models


class Content(models.Model):

    date_learned = models.DateTimeField(auto_now_add=True)
    heading = models.CharField(max_length=100)
    subheading = models.TextField()
    footer = models.TextField()

    def __str__(self):
        return self.heading

class Step(models.Model):

    step_number = models.PositiveSmallIntegerField(default=1)
    content = models.ForeignKey(Content, on_delete=models.CASCADE)
    step_name = models.CharField(max_length=100)

    class Meta:
        ordering = ["step_number"]

    def __str__(self):
        return str(self.step_number) + " " + self.step_name

class Paragraph(models.Model):

    class TextType(models.TextChoices):
        NORMAL = 'NM', _('NORMAL')
        CODE = 'CD', _('CODE')
        BULLET = 'BU', _('BULLET')
        NOTE = 'NT', _('NOTE')

    class Meta:
        ordering = ["order"]
    head = models.CharField(max_length=100)
    order = models.PositiveSmallIntegerField(default=1)
    step = models.ForeignKey(Step, on_delete=models.CASCADE)
    text = models.TextField()
    text_type = models.CharField(
            max_length=2,
            choices=TextType.choices,
            default=TextType.NORMAL,
            )

    def __str__(self):
        return str(self.order) + " " + self.text

tutorials/learned/views.py
from django.shortcuts import render
from django.http import HttpResponse, JsonResponse
from django.views import generic
from .models import Content, Step, Paragraph


def index(request):
    return HttpResponse("<h1>Learned Index</h1>")

class IndexView(generic.ListView):
    template_name = 'learned/search.html'
    context_object_name = 'contents'

    def get_queryset(self):
        return Content.objects.order_by('-heading')

class ContentDetailView(generic.DetailView):
    model = Content
    template = 'learned/detailed.html'
    context_object_name = 'content'


def search(request):
    search = request.GET['query']
    contents = Content.objects.filter(heading__icontains=search)
    return render(request, 'learned/search.html', {
        'contents' : contents,
        'search' : search
        })

def all(request):
    response = Content.objects.all()

    return JsonResponse( { 'response' : response } )


def get_step(pk):
    return Step.objects.filter(content=pk)

def get_paragraph(pk):
    return Paragraph.objects.filter(step=pk)

#def detail(request, pk):
#    content = Content.objects.get(id=pk)
#    steps = get_step(pk)
#    i = 0
#    for step in steps:
#        paragraphs = get_paragraph(step.id)
#        steps[i].paragraphs = paragraphs
#        i += 1
#    content.steps = steps
#
#    return render(request, 'learned/detailed.html', { 'content' : content })

tutorials/tutorials/views.py
from django.http import HttpResponseRedirect
from django.urls import reverse




def index(request):
    return HttpResponseRedirect(reverse('learned:index'))

tutorials/learned/templates/base.html
{% load static %}
<!DOCTYPE html>
<!-- saved from url=(0030)https://www.djangoproject.com/ -->
<html lang="en" class=" mdzr-js mdzr-borderradius mdzr-boxshadow mdzr-cssanimations mdzr-svg">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
		<meta http-equiv="X-UA-Compatible" content="IE=edge">
		<meta name="viewport" content="width=device-width, initial-scale=1">
		<meta name="ROBOTS" content="ALL">
		<meta name="MSSmartTagsPreventParsing" content="true">
		<meta name="Copyright" content="Django Software Foundation">
		<meta name="keywords" content="Python, Django, framework, open-source">
		<meta name="description" content="">

		<!-- Favicons -->
		<link rel="apple-touch-icon" href="{% static 'learned/images/icon-touch.1.png' %}">
		<link rel="apple-touch-icon" href="{% static 'learned/images/drawing.png' %}">
		<link rel="icon" sizes="192x192" href="{% static 'learned/images/icon-touch.2.png' %}">
		<link rel="shortcut icon" href="{% static 'learned/images/favicon.3.ico' %}">
		<meta name="msapplication-TileColor" content="#113228">
		<meta name="msapplication-TileImage" content="{% static 'learned/images/icon-tile.png' %}">

		<title>
			{% if content.heading %}
				{{ content.heading  }} |
			{% endif %}
			 Tutorials
		</title>

		<link rel="stylesheet" href="{% static 'learned/css/output.css' %}">
		<script src="{% static 'learned/js/webfontloader.js' %}"></script>
		<link rel="stylesheet" href="{% static 'learned/css/style.css' %}"><script>
    WebFont.load({
      custom: {
        families: ['FontAwesome', 'Fira+Mono'],
      },
      google: {
        families: ['Roboto:400italic,700italic,300,700,400:latin'
        ]
      },
      classes: false,
      events: false,
      timeout: 1000
    });
		</script>
		<script src="{% static 'learned/js/modernizr.js' %}"></script>
		<script type="text/javascript" charset="utf-8" async="" data-requirecontext="_" data-requiremodule="main" src="{% static 'learned/js/main.js' %}"></script>
		<script type="text/javascript" charset="utf-8" async="" data-requirecontext="_" data-requiremodule="mod/mobile-menu" src="{% static 'learned/js/mobile-menu.js' %}"></script>
		<script type="text/javascript" charset="utf-8" async="" data-requirecontext="_" data-requiremodule="mod/list-feature" src="{% static 'learned/js/list-feature.js' %}"></script>
		<script type="text/javascript" charset="utf-8" async="" data-requirecontext="_" data-requiremodule="jquery" src="{% static 'learned/js/jquery.min.js' %}"></script>
		<script type="text/javascript" charset="utf-8" async="" data-requirecontext="_" data-requiremodule="jquery.inview" src="{% static 'learned/js/jquery.inview.min.js' %}"></script>
	</head>

	<body id="homepage" class="homepage">
		<div role="banner" id="top">
			<div class="container">
				<a class="logo" href="{% url 'index' %}">Tutorials</a>
				<p class="meta">Tutorials about linux.</p>
				<div class="menu-button"><i class="icon icon-reorder"></i>
					<span>Menu</span></div>
				<div role="navigation" class="nav-menu-on">
					<ul>
						<li><a href="#">Overview</a></li>
						<li><a href="#">Tutorials</a></li>
						<li><a href="#">♥ About</a></li>
					</ul>
				</div>
			</div>
		</div>
		<!--
		<div class="copy-banner">
			<div class="container container--flex container--flex--wrap--mobile">
				<h1><a href="https://docs.djangoproject.com/en/4.0/">Documentation</a></h1>
				<form action="https://docs.djangoproject.com/en/4.0/search/" class="search form-input" role="search">
					<label class="visuallyhidden" for="id_q">Search:</label>
					<input type="search" name="q" placeholder="Search 4.0 documentation" id="id_q">
					<button type="submit">
						<i class="icon icon-search"></i>
						<span class="visuallyhidden">Search</span>
					</button>
				</form>
			</div>
		</div
		-->
		<div id="billboard"></div>
		<div class="container sidebar-right">

			{% block content %}{% endblock %}



		</div>











		<div role="contentinfo">


			<div class="footer">

				<div class="container">

					<div class="footer-logo">

						<a class="logo" href="https://www.djangoproject.com/">Django</a>

					</div>

					<ul class="thanks">

						<li>

							<span>Hosting by</span> <a class="in-kind-donors" href="https://www.djangoproject.com/fundraising/#in-kind-donors">In-kind donors</a>

						</li>

						<li class="design"><span>Design by</span> <a class="threespot" href="https://www.threespot.com/">Threespot</a> <span class="ampersand">&amp;</span> <a class="andrevv" href="http://andrevv.com/">andrevv</a></li>

					</ul>

					<p class="copyright">© 2005-2022

					<a href="https://www.djangoproject.com/foundation/"> Django Software

						Foundation</a> and individual contributors. Django is a

					<a href="https://www.djangoproject.com/trademarks/">registered

						trademark</a> of the Django Software Foundation.

					</p>

				</div>

			</div>

		</div>





		<script>

			function extless(input) {

							return input.replace(/(.*)\.[^.]+$/, '$1');

						}

			var require = {

							shim: {

											'jquery': [],

											'jquery.inview': ["jquery"],

											'jquery.payment': ["jquery"],

											'jquery.flot': ["jquery"],

											'jquery.unveil': ["jquery"],

											'stripe': {

															exports: 'Stripe'

														}

										},

							paths: {

											"jquery": extless("{% static 'learned/js/jquery.min.js' %}"),

											"jquery.inview": extless("{% static 'learned/js/jquery.inview.min.js' %}"),

											"jquery.payment": extless("{% static 'learned/js/jquery.payment.js' %}"),

											"jquery.unveil": extless("{% static 'learned/js/jquery.unveil.min.js' %}"),

											"jquery.flot": extless("{% static 'learned/js/jquery.flot.min.js' %}"),

											"clipboard": extless("{% static 'learned/js/clipboard.min.js' %}"),

											"mod/floating-warning": extless("{% static 'learned/js/floating-warning.js' %}"),

											"mod/list-collapsing": extless("{% static 'learned/js/list-collapsing.js' %}"),

											"mod/list-feature": extless("{% static 'learned/js/list-feature.js' %}"),

											"mod/mobile-menu": extless("{% static 'learned/js/mobile-menu.js' %}"),

											"mod/version-switcher": extless("{% static 'learned/js/version-switcher.js' %}"),

											"mod/search-key": extless("{% static 'learned/js/search-key.js' %}"),

											"mod/stripe-change-card": extless("{% static 'learned/js/stripe-change-card.js' %}"),

											"mod/console-tabs": extless("{% static 'learned/js/console-tabs.js' %}"),

											"stripe-checkout": "https://checkout.stripe.com/checkout",

											"stripe": "https://js.stripe.com/v3/?" // ? needed due to require.js

										}

						};

		</script>

		<script data-main="{% static 'learned/js/main.js' %}" src="{% static 'learned/js/require.js' %}"></script>



	</body>
</html>

tutorials/learned/templates/learned/content_detail.html
{% extends 'base.html' %}
{% block content %}
	<div role="">

		<div class="section">

			<h1>{{ content.heading }}</h1>

			<p>{{ content.subheading }}</p>

		</div>
		<div class="section">

			<h2> Contents </h2>

				<ul class="simple">
					{% for step in content.step_set.all %}
						<li>
							<strong><a class="" id="" href="#{{step.step_name}}">{{ step.step_name }}</a> </strong>
						</li>
					{% endfor %}
				</ul>
		</div>


		{% for step in content.step_set.all %}
			<div class="section" id="{{step.step_name}}">
				<h3>{{ step.step_name }}</h3>
				{% for paragraph in step.paragraph_set.all %}
					<!-- normal -->
					{% if paragraph.text_type == 'NM' %}
						<p>{{ paragraph.text }}</p>
					{% elif paragraph.text_type == 'BU' %}
					<!-- bullet -->
						<ul class="simple">
							<li>{{ paragraph.text }}</li>
						</ul>
					{% elif paragraph.text_type == 'NT' %}
						<div class="admonition-where-to-get-help admonition">
							<p class="first admonition-title">Note :</p>
							<p class="last">{{ paragraph.text }}</p>
						</div>
					{% elif paragraph.text_type == 'CD' %}
						<div class="literal-block-wrapper docutils container" id="id6">
							<div class="code-block-caption">
								<span class="caption-text">
									<code class="docutils literal notranslate">
										<span class="pre">{{ paragraph.head }}</span>
									</code>
								</span>
								<a class="headerlink" href="#id6" title="Permalink to this code">¶</a>
							</div>
							<div class="highlight-python notranslate">
								<div class="highlight">
									<pre><span></span><span class="kn">{{ paragraph.text }}</span></pre>
								</div>
							</div>
						</div>

					{% else %}
						<div class="highlight-python notranslate">
							<div class="highlight">
								<pre>
									<span class="s1"><strong>Invalid Paragraph Type</strong></span>
								</pre>
							</div>
						</div>
					{% endif %}
				{% endfor %}
			</div>
		{% endfor %}





	</div>
{% endblock %}

tutorials/learned/templates/learned/detailed.html
{% extends 'base.html' %}
{% block content %}
	<div role="">

		<div class="section">

			<h3 class="result-title">{{ content.heading }}</h3>

			<p>{{ content.subheading }}</p>

		</div>
		<div class="section">

			<h2> Contents </h2>

				<ul class="simple">
					{% for step in content.steps %}
						<li>
							<strong><a class="" id="" href="#{{step.step_name}}">{{ step.step_name }}</a> </strong>
						</li>
					{% endfor %}
				</ul>
		</div>


		{% for step in content.steps %}
			<div class="section" id="{{step.step_name}}">
				<h3>{{ step.step_name }}</h3>
				{% for paragraph in step.paragraphs %}
					<!-- normal -->
					{% if paragraph.text_type == 'NM' %}
						<p>{{ paragraph.text }}</p>
					{% elif paragraph.text_type == 'BU' %}
					<!-- bullet -->
						<ul class="simple">
							<li>{{ paragraph.text }}</li>
						</ul>
					{% elif paragraph.text_type == 'NT' %}
						<div class="admonition-where-to-get-help admonition">
							<p class="first admonition-title">Note :</p>
							<p class="last">{{ paragraph.text }}</p>
						</div>
					{% elif paragraph.text_type == 'CD' %}
						<div class="literal-block-wrapper docutils container" id="id6">
							<div class="code-block-caption">
								<span class="caption-text">
									<code class="docutils literal notranslate">
										<span class="pre">{{ paragraph.head }}</span>
									</code>
								</span>
								<a class="headerlink" href="#id6" title="Permalink to this code">¶</a>
							</div>
							<div class="highlight-python notranslate">
								<div class="highlight">
									<pre><span></span><span class="kn">{{ paragraph.text }}</span></pre>
								</div>
							</div>
						</div>

					{% else %}
						<div class="highlight-python notranslate">
							<div class="highlight">
								<pre>
									<span class="s1"><strong>Invalid Paragraph Type</strong></span>
								</pre>
							</div>
						</div>
					{% endif %}
				{% endfor %}
			</div>
		{% endfor %}





	</div>
{% endblock %}

tutorials/learned/templates/learned/detailed2.html
{% extends 'base.html' %}
{% block content %}
	<div role="main">
		<div class="section" id="s-django-documentation">
			<span id="django-documentation"></span>
			<h1>
				{{ content.title }}<a class="headerlink" href="#" title="Permalink to this headline">¶</a>
			</h1>
			<p class="rubric">{{ content.subheading }}</p>
			<div class="section" id="s-first-steps">
				<span id="s-index-first-steps"></span>
				<span id="first-steps"></span>
				<span id="index-first-steps"></span>
				<h2>
					Contents
					<a class="headerlink" href="#" title="Permalink to this headline">¶</a>
				</h2>
				<ul class="simple">
					{% for step in content.steps %}
						<li>
							<strong><a class="" id="" href="#{{step.step_name}}">{{ step.step_name }}</a> </strong>
						</li>
					{% endfor %}
				</ul>
			</div>
			{% for step in content.steps %}
				<div class="section" id="{{step.step_name}}">
					<h2>{{ step.step_name }}</h2>
					{% for paragraph in step.paragraphs %}
						<!-- normal -->
						{% if paragraph.text_type == 'normal' %}
							<p>{{ paragraph.text }}</p>
						{% elif paragraph.text_type == 'bullet' %}
						<!-- bullet -->
							<ul class="simple">
								<li>{{ paragraph.text }}</li>
							</ul>
						{% elif paragraph.text_type == 'note' %}
							<div class="admonition-where-to-get-help admonition">
								<p class="first admonition-title">Note :</p>
								<p class="last">{{ paragraph.text }}</p>
							</div>
						{% elif paragraph.text_type == 'code' %}
							<div class="literal-block-wrapper docutils container" id="id6">
								<div class="code-block-caption">
									<span class="caption-text">
										<code class="docutils literal notranslate">
											<span class="pre">Terminal</span>
										</code>
									</span>
									<a class="headerlink" href="#id6" title="Permalink to this code">¶</a>
								</div>
								<div class="highlight-python notranslate">
									<div class="highlight">
										<pre><span></span><span class="kn">{{ paragraph.text }}</span></pre>
									</div>
								</div>
							</div>

						{% else %}
							<div class="highlight-python notranslate">
								<div class="highlight">
									<pre>
										<span class="s1"><strong>Invalid Paragraph Type</strong></span>
									</pre>
								</div>
						{% endif %}
					{% endfor %}
			{% endfor %}
		</div>

	</div>
{% endblock %}

tutorials/learned/templates/learned/search.html
{% extends 'base.html' %}
{% load static %}
{% block content %}
	<div id="" class="" role="">
		{% for content in contents %}
			<div id="" class="section" >
				<dt>
					<h2 class="result-title">
						<a href="{% url 'learned:detail' content.id %}">{{ content.heading }}</a>
					</h2>
					<span class="meta breadcrumbs">{{ content.subheading }}</span>
				</dt>
			</div>


		{% endfor %}
	</div>


{% endblock %}

tutorials/learned/templates/sidebar.html
{% block complementary %}
<div role="complementary">

	<a href="https://www.djangoproject.com/download/" class="cta">

		Download <em>latest release: 4.0.5</em>

	</a>

	<a href="https://docs.djangoproject.com/" class="link-readmore">Django documentation</a>





	<div class="fundraising-sidebar">

		<h2>Support Django!</h2>


		<div class="small-heart">

			<img src="./The web framework for perfectionists with deadlines _ Django_files/fundraising-heart.cd6bb84ffd33.svg" alt="Support Django!">

		</div>


		<div class="small-cta">

			<ul class="list-links-small">

				<li><a href="https://www.djangoproject.com/fundraising/">

						VPN.nl donated to the Django Software Foundation to

						support Django development. Donate today!

					</a></li>

			</ul>

		</div>

	</div>




	<h3>Latest news</h3>

	<ul class="list-news">


		<li>

			<h4>

				<a href="https://www.djangoproject.com/weblog/2022/jun/24/pycharm-dsf-campaign-2022-results/">PyCharm &amp; DSF Campaign 2022 Results</a>

			</h4>


			<p>The JetBrains PyCharm Sponsorship Raised $25,000 for Django this year.</p>



			<span class="meta">

				Posted by <strong>William Vincent</strong> on June 24, 2022

			</span>


		</li>



		<li>

			<h4>

				<a href="https://www.djangoproject.com/weblog/2022/jun/21/django-41-beta-1-released/">Django 4.1 beta 1 released</a>

			</h4>


			<p>Today Django 4.1 beta 1, a preview/testing package for the upcoming Django 4.1 release, is available.</p>



			<span class="meta">

				Posted by <strong>Carlton Gibson</strong> on June 21, 2022

			</span>


		</li>


	</ul>


	<a href="https://www.djangoproject.com/weblog/" class="link-readmore">More news</a>


	<h3>New to Django?</h3>

	<ul class="list-links-small docs-list">

		<li><a href="https://docs.djangoproject.com/en/stable/intro/install/">Installation guide</a></li>

		<li><a href="https://docs.djangoproject.com/en/stable/intro/tutorial01/">Write your first Django app</a></li>

	</ul>

	<a href="https://www.djangoproject.com/start/" class="link-readmore">Getting started with Django</a>


	<h3>The power of Django</h3>

	<ul class="list-links-small docs-list">

		<li><a href="https://docs.djangoproject.com/en/stable/topics/db/models/">Object-relational mapper</a></li>

		<li><a href="https://docs.djangoproject.com/en/stable/intro/tutorial02/">Automatic admin interface</a></li>

		<li><a href="https://docs.djangoproject.com/en/stable/topics/templates/">Robust template system</a></li>

		<li><a href="https://docs.djangoproject.com/en/stable/topics/i18n/">Quick internationalization</a></li>

	</ul>

	<a href="https://www.djangoproject.com/start/overview/" class="link-readmore">Explore more features</a>


	<h3>Get involved</h3>

	<dl class="list-links-small">

		<dt><a href="https://code.djangoproject.com/">Ticket system</a></dt>

		<dd>

			Report bugs and make feature requests

		</dd>

		<dt><a href="https://dashboard.djangoproject.com/">Development dashboard</a></dt>

		<dd>

			see what's currently being worked on

		</dd>

	</dl>

	<a href="https://www.djangoproject.com/community/" class="link-readmore">Inside the Django community</a>


	<h3>Get Help</h3>

	<dl class="list-links-small">

		<dt><a href="irc://irc.libera.chat/django">#django IRC channel</a></dt>

		<dd>

			Chat with other Django users

		</dd>


		<dt><a href="https://discord.gg/xcRH6mN4fa" target="_blank">Django Discord Server</a></dt>

		<dd>

			Join the Django Discord Community

		</dd>


		<dt><a href="https://forum.djangoproject.com/" target="_blank">Official Django Forum</a></dt>

		<dd>

			Join the community on the Django Forum.

		</dd>

	</dl>


	<h3>The Django Software Foundation</h3>

	<dl class="list-links-small">

		<dt><a href="https://www.djangoproject.com/foundation/">About the Foundation</a></dt>

		<dd>

			Our non-profit supports the project

		</dd>


		<dt><a href="https://www.djangoproject.com/foundation/donate/">Support Django</a></dt>

		<dd>

			Your contribution makes Django stronger

		</dd>


		<dt><a href="https://www.djangoproject.com/contact/foundation/">Contact the Django Software Foundation</a></dt>

		<dd></dd>

	</dl>

	<a href="https://www.djangoproject.com/foundation/" class="link-readmore">More about the DSF</a>


</div>
{% endblock %}